#ifndef __COMMON_HPP__
#include "common.hpp"
#endif

#ifndef __OSTREAM_PRINTF_HPP__
#include "ostream_printf.hpp"
#endif

#ifndef __NULLSTREAM_HPP__
#include "nullstream.hpp"
#endif

using namespace std;

//------------------------------------------------------------------------
int main( int argc, char* argv[] )
{
  try
  {
    nullstream temp;

    
    /* standard formatted output */
    oprintf( cout, "this call remains the same both in %s builds and %s builds\n", "release", "debug" );

    
    /* debugf allows you to force the compiler to remove the call in debug builds, 
       causing no performance hit */
    debugf(  cout, "this call will be removed from %s builds\n", "release" );


    /* if you pass a nullstream to oprintf, the performance hit will be quite minimal */
    oprintf( temp, "this will also be removed in both %s and %s builds\n", "debug", "release" );

    
    /* test the output function */
    oprintf( cout, "[%03d] rendering speed at %3.2f msec with %d tris/second, cpu usage: %-2.5G%%\n",
      15, 12.456f, 102493, 54.45456f );
  }
  catch(exception& e)
  {
    cerr << "exception caught in main: " << e.what() << endl;
  }
  
  return 0;
}